// This macro shows how to change time coordinate untis into distance unit.
{
// Note that root is supposed to be installed in D:/
// If note, modify the line bellow accordingly.
#include "D:/root/macros/MODAR_.C"

// check read/write access
char *full_path;full_path=new char[600];
char *w0;w0=new char[600];
sprintf(full_path,"%s/example.o",gSystem->WorkingDirectory());
if(gSystem->AccessPathName(full_path,kReadPermission))
	{
	TPaveText *info_text_access_problem=new TPaveText(0.,0.3,1,0.8);
	info_text_access_problem->SetTextColor(1);	
	info_text_access_problem->SetTextAlign(12);	
	info_text_access_problem->SetBorderSize(0);
	info_text_access_problem->SetFillColor(0);
	sprintf(w0,"CANNOT FIND  %s",full_path);
	info_text_access_problem->AddText(w0);	
	printf("%s\n",w0);
	info_text_access_problem->AddText("Change path in Macro.cc or move example.o");	
	printf("Change path in Macro.cc or move example.o\n");
	info_text_access_problem->SetTextColor(2);	
	TCanvas *Cinfo=new TCanvas("Cinfo","Cinfo");
	info_text_access_problem->Draw();
	Cinfo->Update();
	break;
	}

sprintf(full_path,"%s/MODAR.C",gSystem->WorkingDirectory());
if(gSystem->AccessPathName(full_path,kReadPermission))
	{
	TPaveText *info_text_access_problem=new TPaveText(0.,0.3,1,0.8);
	info_text_access_problem->SetTextColor(1);	
	info_text_access_problem->SetTextAlign(12);	
	info_text_access_problem->SetBorderSize(0);
	info_text_access_problem->SetFillColor(0);
	sprintf(w0,"CANNOT FIND  %s",full_path);
	info_text_access_problem->AddText(w0);	
	printf("%s\n",w0);
	info_text_access_problem->AddText("Change path in Macro.cc or move MODAR.C");	
	printf("Change path in Macro.cc or move MODAR.C\n");
	info_text_access_problem->AddText("for example, change");	
	printf("for example, change\n");	
	sprintf(w0,"# include %cMODAR.C%c",34,34);
	printf("%s\n",w0);
	info_text_access_problem->AddText(w0);	
	info_text_access_problem->AddText("into");	
	printf("into\n");
	sprintf(w0,"# include %c/usr/root/macros/MODAR.C%c",34,34);	
	printf("%s\n",w0);
	info_text_access_problem->AddText(w0);	
	info_text_access_problem->SetTextColor(2);	
	TCanvas *Cinfo=new TCanvas("Cinfo","Cinfo");
	info_text_access_problem->Draw();
	Cinfo->Update();
	break;
	}


sprintf(full_path,"%s/NaI5in5in10inSmallFace.C",gSystem->WorkingDirectory());
if(gSystem->AccessPathName(full_path,kReadPermission))
	{
	TPaveText *info_text_access_problem=new TPaveText(0.,0.3,1,0.8);
	info_text_access_problem->SetTextColor(1);	
	info_text_access_problem->SetTextAlign(12);	
	info_text_access_problem->SetBorderSize(0);
	info_text_access_problem->SetFillColor(0);
	sprintf(w0,"CANNOT FIND  %s",full_path);
	info_text_access_problem->AddText(w0);	
	printf("%s\n",w0);
	info_text_access_problem->AddText("Change path in Macro.cc or move NaI5in5in10inSmallFace.C");	
	printf("Change path in Macro.cc or move NaI5in5in10inSmallFace.C\n");	
	info_text_access_problem->AddText("for example, change");	
	printf("for example, change\n");
	sprintf(w0,"MTH2D *F15P_smeared=new MTH2D(*SomeTallies->Get_Tally(0)->Smear(%cNaI5in5in10inSmallFace.C%c,0.09,0));",34,34);
	printf("%s\n",w0);
	info_text_access_problem->AddText(w0);	
	info_text_access_problem->AddText("into");	
	printf("into\n");
	sprintf(w0,"MTH2D *F15P_smeared=new MTH2D(*SomeTallies->Get_Tally(0)->Smear(%c/usr/root/macros/NaI5in5in10inSmallFace.C%c,0.09,0));",34,34);
	printf("%s\n",w0);
	info_text_access_problem->AddText(w0);	
	info_text_access_problem->SetTextColor(2);	
	TCanvas *Cinfo=new TCanvas("Cinfo","Cinfo");
	info_text_access_problem->Draw();
	Cinfo->Update();
	break;
	}

sprintf(full_path,"%s",gSystem->WorkingDirectory());
if(gSystem->AccessPathName(full_path,kWritePermission))
	{
	TPaveText *info_text_access_problem=new TPaveText(0.,0.3,1,0.8);
	info_text_access_problem->SetTextColor(1);	
	info_text_access_problem->SetTextAlign(12);	
	info_text_access_problem->SetBorderSize(0);
	info_text_access_problem->SetFillColor(0);
	sprintf(w0,"CANNOT WRITE IN  %s",full_path);
	printf("%s\n",w0);
	info_text_access_problem->AddText(w0);	
	info_text_access_problem->AddText("Change path in Macro.cc");	
	printf("Change path in Macro.cc\n");
	info_text_access_problem->AddText("for example, change");	
	printf("for example, change\n");
	sprintf(w0,"SomeTallies->Get_Tally(0)->SaveAsMTH2DFile(%cexample_F15P.MTH2D%c);",34,34);
	printf("%s\n",w0);
	info_text_access_problem->AddText(w0);	
	info_text_access_problem->AddText("into");	
	printf("into\n");
	sprintf(w0,"SomeTallies->Get_Tally(0)->SaveAsMTH2DFile(%cMyDirectory/example_F15P.MTH2D%c);",34,34);
	printf("%s\n",w0);
	info_text_access_problem->AddText(w0);	
	info_text_access_problem->SetTextColor(2);	
	TCanvas *Cinfo=new TCanvas("Cinfo","Cinfo");
	info_text_access_problem->Draw();
	Cinfo->Update();
	break;
	}


////////////////////////////////////////////////////////////////////////////////////////////
// Create MODAR main window
////////////////////////////////////////////////////////////////////////////////////////////
gStyle->SetFrameFillColor(0);
TGMainFrame *fMain = new TGMainFrame();
MTH2D_Controller *liste=new MTH2D_Controller(gClient->GetRoot(), fMain, 850, 400,0);

////////////////////////////////////////////////////////////////////////////////////////////
// Load data from example.o
////////////////////////////////////////////////////////////////////////////////////////////
// Note that example.o is supposed to be placed in the same directory as Macro.cc
// If not, modify the following lines accordingly, for example: 
// MCNP_run *SomeTallies=new MCNP_run("D:/root/MyDirectory/example.o",liste,1==1);


MCNP_run *SomeTallies=new MCNP_run("example.o",liste,1==1);

////////////////////////////////////////////////////////////////////////////////////////////
// Save the tallies in .MTH2D files so that they can be used later if needed.
////////////////////////////////////////////////////////////////////////////////////////////

SomeTallies->Get_Tally(0)->SaveAsMTH2DFile("example_F15P.MTH2D");
SomeTallies->Get_Tally(1)->SaveAsMTH2DFile("example_F25P.MTH2D");
SomeTallies->Get_Tally(2)->SaveAsMTH2DFile("example_F35P.MTH2D");

////////////////////////////////////////////////////////////////////////////////////////////
// Smear the tallies with response function: new MTH2D objects with _smear extension are created.
////////////////////////////////////////////////////////////////////////////////////////////
// Energy response function = NaI5in5in10inSmallFace.C
// Time resolution(sigma)= 0.9ns = 0.09 shake 
// Note that NaI5in5in10inSmallFace.C is supposed to be placed in the same directory as Macro.cc
// If not, modify the following lines accordingly, for example: 
// MTH2D *F15P_smeared=new MTH2D(*SomeTallies->Get_Tally(0)->Smear("D:/root/macros/NaI5in5in10inSmallFace.C",0,0));
MTH2D *F15P_smeared=new MTH2D(*SomeTallies->Get_Tally(0)->Smear("NaI5in5in10inSmallFace.C",0.09,0));// first tally of example.o=F15P
MTH2D *F25P_smeared=new MTH2D(*SomeTallies->Get_Tally(1)->Smear("NaI5in5in10inSmallFace.C",0.09,0));// second tally of example.o=F15P
MTH2D *F35P_smeared=new MTH2D(*SomeTallies->Get_Tally(2)->Smear("NaI5in5in10inSmallFace.C",0.09,0));// third tally of example.o=F15P


////////////////////////////////////////////////////////////////////////////////////////////
// Save the smeared tallies in .MTH2D files so that they can be used later if needed.
////////////////////////////////////////////////////////////////////////////////////////////
F15P_smeared->SaveAsMTH2DFile("example_F15P_smeared.MTH2D");

F25P_smeared->SaveAsMTH2DFile("example_F25P_smeared.MTH2D");

F35P_smeared->SaveAsMTH2DFile("example_F35P_smeared.MTH2D");


////////////////////////////////////////////////////////////////////////////////////////////
// Transform time coordinates into distance coordinates.
////////////////////////////////////////////////////////////////////////////////////////////
// Coordinates of the neutron source and tallies
Double_t X0=-190.,Y0=0.,Z0=0.; // coordiantes of the neutron source, see MCNP output file example.o
Double_t Xg_15=-60,Yg_15=0,Zg_15=130;    // coordinates of tally 15, see MCNP output file example.o
Double_t Xg_25=0,Yg_25=0,Zg_25=130;    // coordinates of tally 25, see MCNP output file example.o
Double_t Xg_35=60,Yg_35=0,Zg_35=130;    // coordinates of tally 35, see MCNP output file example.o

// Bin limites defining the distance
// Min distance=-260cm, Max distance=140cm, full interval cut into 198 bins
MTArrayD *DistanceBins=new MTArrayD("   54-       x4 -260 198i 140");

// Relation between the position from where the gamma has been produced along the X axis and the detection time.
// Since time is in shake units (1 shake=10 nanoseconds), divide by 10.
// 14 MeV neutron speed=5.18 cm/ns
// light speed=30 cm/ns
TF1 *Distance_to_Time_Function=new TF1("D_to_T","((x-[0])/5.18+sqrt((x+[3])**2+[4]+[5])/30.)/10.");

// Update the parameters related to the neutron source
Distance_to_Time_Function->SetParameter(0,X0);
Distance_to_Time_Function->SetParameter(1,Y0); 
Distance_to_Time_Function->SetParameter(2,Z0);  

// Transform Time coordinates of tally F15P into distance coordinates
Distance_to_Time_Function->SetParameter(3,-Xg_15); 
Distance_to_Time_Function->SetParameter(4,(Yg_15-Y0)*(Yg_15-Y0));    
Distance_to_Time_Function->SetParameter(5,(Zg_15-Z0)*(Zg_15-Z0));    
MTH2D *F15P_smeared_X=new MTH2D(*F15P_smeared,DistanceBins,Distance_to_Time_Function,"example_F15P_smeared_X","Distance (cm)");

// Transform Time coordinates of tally F25P into distance coordinates
Distance_to_Time_Function->SetParameter(3,-Xg_25); 
Distance_to_Time_Function->SetParameter(4,(Yg_25-Y0)*(Yg_25-Y0));    
Distance_to_Time_Function->SetParameter(5,(Zg_25-Z0)*(Zg_25-Z0));    
MTH2D *F25P_smeared_X=new MTH2D(*F25P_smeared,DistanceBins,Distance_to_Time_Function,"example_F25P_smeared_X","Distance (cm)");

// Transform Time coordinates of tally F35P into distance coordinates
Distance_to_Time_Function->SetParameter(3,-Xg_35); 
Distance_to_Time_Function->SetParameter(4,(Yg_35-Y0)*(Yg_35-Y0));    
Distance_to_Time_Function->SetParameter(5,(Zg_35-Z0)*(Zg_35-Z0));    
MTH2D *F35P_smeared_X=new MTH2D(*F35P_smeared,DistanceBins,Distance_to_Time_Function,"example_F35P_smeared_X","Distance (cm)");



////////////////////////////////////////////////////////////////////////////////////////////
// Save the transformed tallies in .MTH2D files so that they can be used later if needed.
////////////////////////////////////////////////////////////////////////////////////////////
F15P_smeared_X->SaveAsMTH2DFile("example_F15P_smeared_X.MTH2D");

F25P_smeared_X->SaveAsMTH2DFile("example_F25P_smeared_X.MTH2D");

F35P_smeared_X->SaveAsMTH2DFile("example_F35P_smeared_X.MTH2D");

////////////////////////////////////////////////////////////////////////////////////////////
// Sum the transformed tallies
////////////////////////////////////////////////////////////////////////////////////////////
MTH2D *Sum=new MTH2D(*F15P_smeared_X);Sum->SetName("Sum");
Sum->Add(F25P_smeared_X);
Sum->Add(F35P_smeared_X);
Sum->SetMTH2D_Controller(liste);
Sum->DoDraw();

////////////////////////////////////////////////////////////////////////////////////////////
// Save the sum
////////////////////////////////////////////////////////////////////////////////////////////
Sum->SaveAsMTH2DFile("Sum.MTH2D");
}
